--------------------------------------------------------------
-- Puissance 4
--
-- Jessy GAUTRAND, Pascal MIETLICKI, Romain SCHMITT 
-- INSA, Departement Genie Informatique
-- version adb
-- paquetage cre  la main pour la confirmation de fermeture
-- de la fenetre par l'utilisateur
-- Compilee, testee avec succes
--------------------------------------------------------------


package body My_Dialog is

function "-" (Msg : String) return String is
   begin
      return Dgettext ("Quitter", Msg);
   end "-";

procedure Gtk_New (Window : out Window_Access) is
begin
   Window := new Window_Record;
   Initialize (Window);
end Gtk_New;

procedure Initialize (Window : access Window_Record'Class) is
   pragma Suppress (All_Checks);
    
   
begin
   Gtk.Window.Initialize (Window, Window_Toplevel);
   Set_Border_Width (Window, 4);
   Set_Title (Window, -"Sortie");
   Set_Position (Window, Win_Pos_None);
   Set_Modal (Window, False);
   Set_Resizable (Window, True);

   Gtk_New_Vbox (Window.Vbox, False, 0);

   Gtk_New (Window.Label, -("Etes-vous certain de vouloir quitter la partie?"));
   Set_Alignment (Window.Label, 0.5, 0.5);
   Set_Padding (Window.Label, 0, 0);
   Set_Justify (Window.Label, Justify_Left);
   Set_Line_Wrap (Window.Label, False);
   Set_Selectable (Window.Label, False);
   Set_Use_Markup (Window.Label, False);
   Set_Use_Underline (Window.Label, False);

   Pack_Start
     (Window.Vbox,
      Window.Label,
      Expand  => True,
      Fill    => True,
      Padding => 0);
   Gtk_New_Hbox (Window.Hbox, False, 0);

   Gtk_New_From_Stock (Window.Oui, "gtk-yes");
   Set_Border_Width (Window.Oui, 4);
   Set_Relief (Window.Oui, Relief_Normal);

   Pack_Start
     (Window.Hbox,
      Window.Oui,
      Expand  => True,
      Fill    => True,
      Padding => 0);
  
   Gtk_New_From_Stock (Window.Non, "gtk-no");
   Set_Border_Width (Window.Non, 4);
   Set_Relief (Window.Non, Relief_Normal);

   Pack_Start
     (Window.Hbox,
      Window.Non,
      Expand  => True,
      Fill    => True,
      Padding => 0);
  
   Pack_Start
     (Window.Vbox,
      Window.Hbox,
      Expand  => True,
      Fill    => True,
      Padding => 0);
   Add (Window, Window.Vbox);
end Initialize;

end My_Dialog;
